// deployer main programm
// Copyright (C) 2024 Jean-Cloud
// GNU General Public License v3

#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <cstring>
#include "Services.h"
#include "DockerModule.h"
using namespace std;

void help()
{
    //temporary 
    cout << "usage: ./$argv[0] action file \n with action=deploy or remove and file=path to a file or all. \n" << endl;
}

int isServiceOnServer()
//this method tests if a certain service is on the current server
//it uses the bash command dig, thanks to a pipe to a separate bash process
{
    FILE *p;
    char result [100];

    p = popen("ls -la","r"); //just to test that popen works
    if( p == NULL)
    {
        cout << "Unable to verify if the service is on the server, bash process opening error." << endl;
        return -1;
    }
    while(fgets(result,100,p)!=NULL){
        //if several lines, copy result somewhere to save
        cout << result << endl;
    }
    pclose(p);
    return 0;
}

int main(int argc, char *argv[])
{
    bool action_deploy=false;
    bool action_remove=false;
    bool all=false;
    //list<Module *> modules;
    if (argc != 3){
        cout << "Invalid number of arguments. \n" << endl;
        help();
        exit(1);
    } else {
        if (strcmp(argv[1],"deploy")==0){
            action_deploy=true;
        } else if (strcmp(argv[1],"remove")==0){
            action_remove=true;
        } else {
            cout << "Invalid argument. \n" << endl;
            exit(1);
        }

        DockerModule dmodule;      
        isServiceOnServer();   
    }
    return 0;
}


